//--basic test - start this and then restart the ESP32
(
NetAddr.broadcastFlag_(true);
NetAddr("192.168.1.255", 17122).sendMsg(\pang);
OSCFunc({|msg|
	msg.postln;  //incoming ping
	n= NetAddr("%.%.%.%".format(*msg[2..]), 17122);
}, \f0pwm_ping, recvPort: 17123);
)

//either 0.0-1.0
n.sendMsg(\pin, 0, 1);  //pin 0 100%
n.sendMsg(\pin, 0, 0.25);  //pin 0 25%
n.sendMsg(\pin, 1, 0.5);  //pin 1 50%

//or 0-100
n.sendMsg(\pwm, 0, 95);  //pin 0 95%
n.sendMsg(\pwm, 1, 33);  //pin 1 33%

//pin 0 20%, pin 1 50%
n.sendMsg(\pins, *[0.2, 0.5, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]);
//pin 0 60%, pin 1 30%
n.sendMsg(\pwms, *[60, 30, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]);


//fade on a single channel
~channel= 0;
(
r.stop;
r= Routine.run({
	inf.do{|i|
		n.sendMsg(\pin, ~channel, sin(i/100)/2+0.5);
		0.01.wait;
	};
});
)
~channel= 0;  //P32
~channel= 1;  //P33
~channel= 2;  //P25
~channel= 3;  //P26
~channel= 4;  //P27
~channel= 5;  //P14
~channel= 6;  //P12
~channel= 7;  //P13

~channel= 8;  //P15
~channel= 9;  //P2
~channel= 10;  //P0
~channel= 11;  //P4
~channel= 12;  //P16
~channel= 13;  //P17
~channel= 14;  //P5
~channel= 15;  //P18

~channel= 16;  //P19
~channel= 17;  //P21
~channel= 18;  //P22
~channel= 19;  //P23
r.stop;


//change frequency
n.sendMsg(\pin, 0, 0.5);  //pin 0 50%
n.sendMsg(\pin, 19, 0.5);  //pin 19 50%
n.sendMsg(\freq, 5000);
n.sendMsg(\freq, 2000);
n.sendMsg(\freq, 1000);  //default freq. this is also the max for pins 16-19
n.sendMsg(\freq, 500);
n.sendMsg(\freq, 100);
n.sendMsg(\freq, 200);
n.sendMsg(\freq, 50);
n.sendMsg(\freq, 1);  //minimum
n.sendMsg(\freq, 10000);  //10kHz
n.sendMsg(\freq, 50000);  //50kHz
n.sendMsg(\freq, 70000);  //circa maximum


//via serial port
SerialPort.listDevices;
p= SerialPort("/dev/tty.SLAB_USBtoUART", 57600);
p.putAll(Int8Array[150, 151, 152, 127, 63, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 127, 153]);
p.close

